/*
 * Utility functions
 */
/*
 *  This is part of ypp-sc-tools, a set of third-party tools for assisting
 *  players of Yohoho Puzzle Pirates.
 * 
 *  Copyright (C) 2009 Ian Jackson <ijackson@chiark.greenend.org.uk>
 * 
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 * 
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 * 
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * 
 *  Yohoho and Puzzle Pirates are probably trademarks of Three Rings and
 *  are used without permission.  This program is not endorsed or
 *  sponsored by Three Rings.
 */

#include "common.h"

#define dbassert(x)							\
  ((x) ? (void)0 :							\
     fatal("Error in database.\n"					\
	   " Requirement not met: %s:%d: %s", __FILE__,__LINE__, #x))

void fgetsline(FILE *f, char *lbuf, size_t lbufsz) {
  errno=0;
  char *s= fgets(lbuf,lbufsz,f);
  sysassert(!ferror(f));
  dbassert(!feof(f));
  assert(s);
  int l= strlen(lbuf);
  dbassert(l>0);  dbassert(lbuf[--l]='\n');
  lbuf[l]= 0;
}

void *mmalloc(size_t sz) {
  void *r;
  if (!sz) return 0;
  sysassert( r= malloc(sz) );
  return r;
}
void *mrealloc(void *p, size_t sz) {
  assert(sz);
  void *r;
  sysassert( r= realloc(p,sz) );
  return r;
}
